#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const long long MAX_N = 1e5 + 10;
const long long INF = 1e9 + 10;

void solve () {
    long long n, k;

    cin >> n >> k;

    if (n <= 1) {
        cout << 1 << endl;
        return;
    }

    if (k == 2) {
        cout << n << endl;
        return;
    }

    if (n <= k) {
        cout << k << endl;
        return;
    }

    long long powers[1000];
    powers[0] = 1;
    for (long long i = 1; i < 20; i ++) {
        if (powers[i - 1] * 3 < 0) break;
        powers[i] = powers[i - 1] * k;
    }

    for (long long i = 0; i <= 1050; i ++) {
        long long current = 0;
        for (long long bit = 0; bit <= 20; bit ++) {
            if (i & (1 << bit)) {
                current += powers[bit];
            }
        }
        // if (k == 3) cout << current << endl;
        if (current >= n) {
            cout << current << endl;
            return;    
        }
    }
}

signed main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif
    
    long long q;
    cin >> q;

    for (long long i = 0; i < q; i ++) {
        solve ();
    }
    
    return 0;
}