#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const int MAX_N = 1e5 + 10;
const int INF = 1e9 + 10;


int n, k;
pair<int, int> parent[MAX_N];
int value[MAX_N];
bool isNotLeaf[MAX_N];
bool isD[MAX_N];

int ans = INF;

vector <int> leaves;

bool checked[MAX_N];
int sim () {
    for (int i = 0; i <= n; i ++) {
        checked[i] = false;
    }

    int price = 0;
    
    for (int i = 1; i <= n; i ++) {
        if (checked[i]) continue;
        int current = i;
        int trees = value[current];
        while (!isD[current]) {
            checked[current] = true; 
            price += trees * parent[current].second;
            current = parent[current].first;
            if (!checked[current]) trees += value[current];
        }
    }

    return price;
}

void solve (int ind, int k_) {
    if (k_ == 0) {
        // for (int i = 0; i <= n; i ++) {
        //     if (isD[i]) cerr << i << " ";
        // }

        int currentAns = sim();

        // cerr << "- " << currentAns << endl;

        ans = min(ans, currentAns);
        return;
    }

    if (ind >= n + 1) return;
    if (n - ind + 1 < k_) return; 

    isD[ind] = true;
    solve(ind + 1, k_ - 1);
    isD[ind] = false;
    solve(ind + 1, k_);
}

int main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif
    
    cin >> n >> k;

    for (int i = 1; i <= n; i ++) {
        int w, v, d;
        cin >> w >> v >> d;
        value[i] = w;
        parent[i] = {v, d};
        isNotLeaf[v] = true;
    }    

    for (int i = 1; i <= n; i ++) {
        if (!isNotLeaf[i]) leaves.push_back(i);
    }
    
    isD[0] = true;

    solve(1, k);

    cout << ans << endl;
    return 0;
}