#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const int MAX_N = 1e5 + 10;
const int INF = 1e9 + 10;


int n, k;
pair<int, int> parent[MAX_N];
int value[MAX_N];
bool isD[MAX_N];

int ans = INF;


bool checked[MAX_N];
int sim () {
    for (int i = 0; i <= n; i ++) {
        checked[i] = false;
    }

    int price = 0;
    
    for (int i = n; i >= 1; i --) {
        if (checked[i]) continue;
        int current = i;
        int trees = value[current];
        while (!isD[current]) {
            checked[current] = true; 
            price += trees * parent[current].second;
            current = parent[current].first;
            if (!checked[current]) trees += value[current];
        }
    }

    return price;
}

priority_queue <pair<int, int>> pq;

int suffix[MAX_N];

int main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif
    
    cin >> n >> k;

    for (int i = 1; i <= n; i ++) {
        int w, v, d;
        cin >> w >> v >> d;
        value[i] = w;
        parent[i] = {v, d};
    }    

    suffix[n] = value[n];
    for (int i = n - 1; i >= 1; i --) {
        suffix[i] = suffix[i + 1] + value[i]; 
    }

    for (int i = 1; i <= n; i ++) {
        int sum = suffix[i] - suffix[min(n, i + n / (k + 1))]; 
        pq.push({sum * parent[i].second, i});
    }


    for (int i = 0; i < k; i ++) {
        int node = pq.top().second;
        pq.pop();

        cerr << node << endl;
        isD[node] = true;
    }

    isD[0] = true;
    cout << sim () << endl;
    


    return 0;
}