# include <iostream>
using namespace std;

const int MAX=52;
char a[MAX][MAX];
int adj[4][2]={{0,1},{1,0},{-1,0},{0,-1}};
int n,K;

bool in(int x, int y)
{
    return (1<=x and x<=n and 1<=y and y<=n and a[x][y]!='1');
}

void read()
{
    cin>>n>>K;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++) cin>>a[i][j];
    }
}

long long dp[MAX][MAX][2];

int f(int x)
{
    return (x&1);
}

void solve()
{
    dp[1][1][0]=1;
    for(int k=0;k<K;k++)
    {
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                dp[i][j][f(k+1)]=0;
            }
        }

        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                for(int d=0;d<4;d++)
                {
                    int x=i+adj[d][0];
                    int y=j+adj[d][1];

                    if(in(x,y)) dp[x][y][f(k+1)]+=dp[i][j][f(k)];
                }
            }
        }
    }

    cout<<dp[n][n][f(K)]<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    read();
    solve();

    return 0;
}
