#include <bits/stdc++.h>
using namespace std;

vector <long long> get(long long n, long long k) {
    vector <long long> ans;

    while (n) {
        ans.push_back(n % k);
        n /= k;
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> q;

    while (q--) {
        long long n, k;
        cin >> n >> k;

        auto v = get(n, k);
        v.push_back(0);

        for (int i = v.size() - 1; i >= 0; i--) {
            if (v[i] > 1) {
                int pointer = i + 1;

                for (pointer; pointer < v.size(); pointer++) {
                    if (v[pointer] == 0) {
                        v[pointer] = 1;
                        break;
                    }
                }

                for (int j = pointer - 1; j >= 0; j--) v[j] = 0;

                break;
            }
        }

        long long ans = 0;

        while (v.size()) {
            ans *= k;
            ans += v.back();
            v.pop_back();
        }

        cout << ans << '\n';
    }

    return 0;

}
