#include <algorithm>
#include "segment.h"
#define ll long long
std::vector<int> nums;

int nod(int a, int b) {
	if (a < b) {
		int temp = a;
		a = b;
		b = temp;
	}
	while (b != 0) {
		int temp = b;
		b = a % b;
		a = temp;
	}
	return a;
}

ll divAndConq(int l, int r) {
	if (l == r) {
		return 0;
	}
	ll gcd = nums[l];
	for (int i = l + 1; i < r; i++) {
		gcd = nod(gcd, nums[i]);
	}
	int lastOne = l;
	ll ans = 0;
	for (int i = l; i < r; i++) {
		nums[i] /= gcd;
		if (nums[i] == 1) {
			ans = std::max(ans, gcd * divAndConq(lastOne, i));
			lastOne = i + 1;
		} else {
			if (i == r - 1) {
				ans = std::max(ans, gcd * divAndConq(lastOne, r));
			}
		}
	}
//	std::cout << l << ' ' << r << ' ' << gcd << ' ' << ans << '\n';
	return std::max(ans, (ll)(r - l + 1) * gcd);
}

long long max_segment(std::vector<int> A) {
	for (int i = 0; i < A.size() - 1; i++) {
		nums.push_back(nod(A[i], A[i + 1]));
	}
	return divAndConq(0, A.size() - 1);
}


