#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int MAXN = 51;
const int MAXK = 101;
int N, K;
string Table[MAXN];
llong dp[MAXN][MAXN][MAXK];
bool Visited[MAXN][MAXN][MAXK];
int DirsX[5] = {0, 0, -1, 1};
int DirsY[5] = {-1, 1, 0, 0};

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K;

    for(int i = 0; i < N; i++)
    {
        cin >> Table[i];
    }
}

llong Calculate(int X, int Y, int  CurrentK)
{
    if(X < 1 || X > N || Y < 1 || Y > N) return 0;
    if(Table[X - 1][Y - 1] == '1') return 0;
    if(X == 1 && Y == 1 && CurrentK == 0) return 1;
    if(CurrentK == 0) return 0;
    if(Visited[X][Y][CurrentK]) return dp[X][Y][CurrentK];
    Visited[X][Y][CurrentK] = true;

    for(int Rotate = 0; Rotate < 4; Rotate++)
    {
        int Nx = X + DirsX[Rotate];
        int Ny = Y + DirsY[Rotate];
        dp[X][Y][CurrentK] += Calculate(Nx, Ny, CurrentK - 1);
    }

    return dp[X][Y][CurrentK];
}

void Solve()
{
    cout << Calculate(N, N, K);
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
