#include <bits/stdc++.h>
#include "segment.h"
using namespace std;

const int MAXVALUE = 2 * 1e9;
const int MAXN = 3 * 1e6 + 1;
std :: unordered_set<int> Divisors;
std :: vector<int> Positions[10 * MAXN];
std :: unordered_map<int, int> Decode;
int Code;

long long max_segment(std :: vector<int> A)
{
    for(int i = 0; i < (int)A.size(); i++)
    {
        for(int j = 1; j * j <= A[i]; j++)
        {
            if(A[i] % j != 0)
            {
                continue;
            }

            if(Decode[j] == 0)
            {
                Code++;
                Decode[j] = Code;
                Divisors.insert(j);
                Positions[Code].push_back(i);
            }
            else
            {
                Positions[Decode[j]].push_back(i);
            }

            if(j * j != A[i])
            {
                int k = A[i] / j;

                if(Decode[k] == 0)
                {
                    Code++;
                    Decode[k] = Code;
                    Divisors.insert(k);
                    Positions[Code].push_back(i);
                }
                else
                {
                    Positions[Decode[k]].push_back(i);
                }
            }
        }
    }

    long long Answer = 0;

    for(auto& Div : Divisors)
    {
        long long Index = Decode[Div];
        long long Previous = -1;
        long long Curr = 0;
        long long Max = 0;

        for(auto& i : Positions[Index])
        {
            if(Previous == -1 || i - Previous == 1)
            {
                Curr++;
            }
            else
            {
                Max = max(Max, Curr);
                Curr = 1;
            }

            Previous = i;
        }

        Max = max(Max, Curr);

        Answer = max(Answer, (long long)(Max * Div));
    }

    return Answer;
}