#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 2e5 + 10;

string s, t;
int n, m;

void read()
{
    cin >> s >> t;
    n = s.size();
    m = t.size();
}

void solve_bruteforce()
{
    bool lampa = false;

    /// 1 -> ostawa; 0 -> ne ostava (maha se)

    for(int mask = 0; mask < (1 << n); mask++)
    {
        int len = 0;
        bool even = true;
        string news = "";

        for(int i = 0; i < n; i++)
        {
            if(mask & (1 << i))
            {
                if(len % 2 != 0)
                {
                    even = false;
                    break;
                }
                len = 0;

                news += s[i];
            }
            else
            {
                len++;
            }
        }
        if(len % 2 != 0)
            even = false;

        if(even && news == t)
        {
            lampa = true;
            break;
        }
    }

    if(lampa)
    {
        cout << "YES" << endl;
    }
    else
    {
        cout << "NO" << endl;
    }
}

void solve_minus1()
{
    bool lampa = false;
    for(int i = 1; i < n; i++)
    {
        bool cur = true;

        for(int j = 0; j < i - 1; j++)
        {
            if(s[j] != t[j])
            {
                cur = false;
                break;
            }
        }

        for(int j = i + 1; j < n; j++)
        {
            if(s[j] != t[j - 2])
            {
                cur = false;
                break;
            }
        }

        if(cur)
        {
            lampa = true;
            break;
        }
    }

    if(lampa)
    {
        cout << "YES" << endl;
    }
    else
    {
        cout << "NO" << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    
    if(n == m + 2)
    {
        solve_minus1();
    }
    else
    {
        solve_bruteforce();
    }

    return 0;
}