#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 2e5 + 10;
const int HASH = 3;
const int MOD = 1e9 + 7;

string s, t;
int n, m;

int pw[MAXN];
int h[MAXN];

void read()
{
    cin >> s >> t;
    n = s.size();
    m = t.size();
}

void solve_bruteforce()
{
    bool lampa = false;

    /// 1 -> ostawa; 0 -> ne ostava (maha se)

    for(int mask = 0; mask < (1 << n); mask++)
    {
        int len = 0;
        bool even = true;
        string news = "";

        for(int i = 0; i < n; i++)
        {
            if(mask & (1 << i))
            {
                if(len % 2 != 0)
                {
                    even = false;
                    break;
                }
                len = 0;

                news += s[i];
            }
            else
            {
                len++;
            }
        }
        if(len % 2 != 0)
            even = false;

        if(even && news == t)
        {
            lampa = true;
            break;
        }
    }

    if(lampa)
    {
        cout << "YES" << endl;
    }
    else
    {
        cout << "NO" << endl;
    }
}

void solve()
{
    int last = -1;
    int j = 0;
    for(int i = 0; i < n; i++)
    {
        if(j == m)
        {
            cout << "YES" << endl;
            return;
        }

        if(s[i] == t[j])
        {
            int len = i - last + 1;
            if(len % 2 == 0)
            {
                last = i;
                j++;
            }
        }
    }

    cout << "NO" << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve_bruteforce();

    return 0;
}