#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const int MAX_N = 50 + 10;
const int MAX_K = 100 + 10;
const int INF = 1e9 + 10;

int n, k;
int table[MAX_N][MAX_N];
long long dp[MAX_N][MAX_N][MAX_K];

bool isIn (int x, int y) {
    return x >= 0 && y >= 0 && x < n && y < n;
}

int main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif

    cin >> n >> k;

    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < n; j ++) {
            char c;
            cin >> c;
            table[i][j] = c - '0';
        }
    } 

    dp[0][0][0] = 1;

    for (int step = 1; step <= k; step ++) {
        for (int i = 0; i < n; i ++) {
            for (int j = 0; j < n; j ++) {
                if (table[i][j] == 1) continue;
                
                long long temp = 0;
                if (isIn (i - 1, j)) temp += dp[i - 1][j][step - 1];
                if (isIn (i + 1, j)) temp += dp[i + 1][j][step - 1];
                if (isIn (i, j - 1)) temp += dp[i][j - 1][step - 1];
                if (isIn (i, j + 1)) temp += dp[i][j + 1][step - 1];
                dp[i][j][step] = temp;
            }
        }
    }
    
    cout << dp[n - 1][n - 1][k] << endl;
    
    
    return 0;
}