#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const int MAX_N = 1e5 + 10;
const int INF = 1e9 + 10;


string a;
string b;

vector <int> poses[30];

int bs (int val, int ind) {
    int left = 0, right = poses[ind].size() - 1, mid, ans = -1;

    while (left <= right) {
        mid = (left + right) / 2;

        if (poses[ind][mid] >= val) {
            ans = mid;
            right = mid - 1;
        } else {
            left = mid + 1;
        }
    }

    return ans;
} 

bool solve (int bind, int minInd) {
    if (bind == b.size()) return true;
    if (minInd == a.size()) return false;

    int temp = b[bind] - 'a';
    int stratingIndex = bs(minInd, temp);
    for (int i = stratingIndex; i < poses[temp].size(); i ++) {
        if ((poses[temp][i] - (minInd - 1) + 1) % 2 == 1) continue;
        if (solve(bind + 1, poses[temp][i] + 1)) {
            return true;
        }
    }
    return false;
}

int main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif

    cin >> a >> b;

    for (int i = 0; i < a.size(); i ++) {
        poses[a[i] - 'a'].push_back(i);
    }

    bool ans = solve(0, 0);

    if (ans) cout << "YES" << endl;
    else cout << "NO" << endl;

    return 0;
}