# include <iostream>
# include <vector>
using namespace std;

const int MAX=1e2+11;
vector<int> a[MAX];
int parrent[MAX];
long long pd[MAX];
long long w[MAX];
int n,k;

void Read()
{
    cin>>n>>k;
    for(int i=1;i<=n;i++)
    {
        int v, W, d;
        cin>>W>>v>>d;

        a[v].push_back(i);
        a[i].push_back(v);
        parrent[i]=v;
        pd[i]=d;
        w[i]=W;
    }
}

long long dist[MAX][MAX];
int vis[MAX];
int TM=0;

void dfs1(int start, int curr, long long d)
{
    dist[start][curr]=d;
    vis[curr]=TM;
    for(int nxt: a[curr])
    {
        if(vis[nxt]==TM) continue;
        if(parrent[curr]==nxt) dfs1(start,nxt,d+pd[curr]);
        else dfs1(start,nxt,d+pd[nxt]);
    }
}

void get_dist()
{
    for(int i=0;i<=n;i++)
    {
        TM++;
        dfs1(i,i,0);
        //for(int j=0;j<=n;j++) cout<<i<<"->"<<j<<" "<<dist[i][j]<<"\n";
    }
}

const long long INF=1e18;
int used[MAX];

bool print=0;

long long dfs(int curr, int cl)
{
    //if(print) cout<<curr<<" "<<cl<<"\n";

    if(used[curr]==TM) cl=curr;
    long long ans=0;

    ans+=dist[curr][cl]*w[curr];
    for(int nxt: a[curr])
    {
        if(nxt==parrent[curr]) continue;
        ans+=dfs(nxt,cl);
    }

    return ans;
}

void Solve()
{
    get_dist();
    long long ans=INF;
    for(int mask=0;mask<(1<<(n+1));mask++)
    {
        if((mask&1)>0) continue;
        if(__builtin_popcount(mask)!=k) continue;

        TM++;
        used[0]=TM;
        for(int bit=0;bit<=n;bit++)
        {
            if(((1<<bit)&mask)>0) used[bit]=TM;
        }

        //if(mask==12) print=1;
        ans=min(ans,dfs(0,0));

        //print=0;
    }

    cout<<ans<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    Read();
    Solve();

    return 0;
}



