#include <bits/stdc++.h>
using namespace std;

int w[101], parent[101], children[101], dist[101];
int n, k, DFS, mn = INT_MAX;

bool chosen[101];

vector <pair <int, int>> edges[101];

pair <int, int> simulate(int u) { /// {amount, sum}
    int amount = w[u], sum = 0;


    for (auto p : edges[u]) {
        int x = p.first, d = p.second;
        auto info = simulate(x);
        sum += info.second;

        if (!chosen[x]) {
            amount += info.first;
            sum += info.first * d;
        }
    }

    return {amount, sum};
}

void brute(int n, int k) {
    if (n == 0) {
        DFS++;
        mn = min(mn, simulate(0).second);
        return;
    }

    if (n > k) {
        chosen[n] = 0;
        brute(n - 1, k);
    }

    if (k > 0) {
        chosen[n] = 1;
        brute(n - 1, k - 1);
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;

    for (int i = 1; i <= n; i++) {
        cin >> w[i] >> parent[i] >> dist[i];
        edges[parent[i]].push_back({i, dist[i]});
    }

    brute(n, k);
    cout << mn << endl;
    return 0;

}
