#include <bits/stdc++.h>
#include "segment.h"
using namespace std;

long long n, a[3000001], segment[12000001];

long long build(int idx, int l, int r) {
    if (l == r) return segment[idx] = a[l];
    int m = (l + r) / 2;

    return segment[idx] = __gcd(build(2 * idx, l, m), build(2 * idx + 1, m + 1, r));
}

long long gcd(int idx, int l, int r, int ql, int qr) {
    if (l > r || ql > qr) return 0;
    if (qr < l || r < ql) return 0;
    if (ql <= l && r <= qr) return segment[idx];

    int m = (l + r) / 2;
    return __gcd(gcd(2 * idx, l, m, ql, qr), gcd(2 * idx + 1, m + 1, r, ql, qr));
}

long long next(int l_start, int r_start) {
    int l = l_start, r = r_start, ans = r + 1;
    long long val = gcd(1, 1, n, l, r);

    while (l <= r) {
        int m = (l + r) / 2;
        long long next_val = gcd(1, 1, n, m, r_start);

        if (next_val > val) {
            ans = m;
            r = m - 1;
        } else {
            l = m + 1;
        }
    }

    return ans;
}

long long max_segment(vector <int> v) {
    n = v.size();

    for (int i = 0; i < n; i++) {
        a[i + 1] = v[i];
    }

    build(1, 1, n);
    long long mx = a[1];

    set <int> l_values{1};

    for (int r = 2; r <= n; r++) {
        if (gcd(1, 1, n, r, r) != gcd(1, 1, n, r - 1, r)) l_values.insert(r);
        int buffer = 0;

        for (auto it = l_values.begin(); it != l_values.end();) {
            int l = *it;
            it++;

            if (it == l_values.end()) continue;

            int next = *it, current = buffer;
            buffer = gcd(1, 1, n, next, r);

            if (current == buffer) l_values.erase(it);
            it++;
        }

        for (int l : l_values) {
            mx = max(mx, (r - l + 1) * gcd(1, 1, n, l, r));
        }
    }

    return mx;
}
