#include <bits/stdc++.h>
//#include "segment.h"
using namespace std;

long long n, a[3000001], segment[12000001];


int sparse[3000001][22];
int lg[3000001];

void build(int n) {
    for (int i = 0; i <= 21; i++) {
        lg[1 << i] = i;
    }

    sparse[1][0] = a[1];

    for (int i = 2; i <= n; i++) {
        if (lg[i] == 0) lg[i] = lg[i - 1];
        sparse[i][0] = a[i];
    }

    for (int i = 1; i <= lg[n]; i++) {
        for (int j = 1; j <= n - (1 << i) + 1; j++) {
            sparse[j][i] = __gcd(sparse[j][i - 1], sparse[j + (1 << (i - 1))][i - 1]);
        }
    }
}

long long gcd(int l, int r) {
    int LOG = lg[r - l + 1];

    return __gcd(sparse[l][LOG], sparse[r - (1 << LOG) + 1][LOG]);
}

/**long long build(int idx, int l, int r) {
    if (l == r) return segment[idx] = a[l];
    int m = (l + r) / 2;

    return segment[idx] = __gcd(build(2 * idx, l, m), build(2 * idx + 1, m + 1, r));
}

long long gcd(int idx, int l, int r, int ql, int qr) {
    if (l > r || ql > qr) return 0;
    if (qr < l || r < ql) return 0;
    if (ql <= l && r <= qr) return segment[idx];

    int m = (l + r) / 2;
    return __gcd(gcd(2 * idx, l, m, ql, qr), gcd(2 * idx + 1, m + 1, r, ql, qr));
}*/

long long next(int l_start, int r_start) {
    int l = l_start, r = r_start, ans = r + 1;
    long long val = gcd(l, r);

    while (l <= r) {
        int m = (l + r) / 2;
        long long next_val = gcd(m, r_start);

        if (next_val > val) {
            ans = m;
            r = m - 1;
        } else {
            l = m + 1;
        }
    }

    return ans;
}

long long max_segment(vector <int> v) {
    n = v.size();

    for (int i = 0; i < n; i++) {
        a[i + 1] = v[i];
    }

    build(n);
    long long mx = 0;

    for (int r = 1; r <= n; r++) {
        int l = 1;

        while (l <= r) {
            mx = max(mx, (r - l + 1) * gcd(l, r));
            l = next(l, r);
        }
    }

    return mx;
}

int main() {

    vector <int> v;
    int x;
    while (cin >> x) v.push_back(x);
    cout << max_segment(v) <<endl;

    return 0;

}
