#include <bits/stdc++.h>
#include "segment.h"
using namespace std;

long long n, a[3000001];

int sparse[3000001][22];
int lg[3000001];

void build(int n) {
    for (int i = 0; i <= 21; i++) {
        lg[1 << i] = i;
    }

    sparse[1][0] = a[1];

    for (int i = 2; i <= n; i++) {
        if (lg[i] == 0) lg[i] = lg[i - 1];
        sparse[i][0] = a[i];
    }

    for (int i = 1; i <= lg[n]; i++) {
        for (int j = 1; j <= n - (1 << i) + 1; j++) {
            sparse[j][i] = __gcd(sparse[j][i - 1], sparse[j + (1 << (i - 1))][i - 1]);
        }
    }
}

long long gcd(int l, int r) {
    int LOG = lg[r - l + 1];

    return __gcd(sparse[l][LOG], sparse[r - (1 << LOG) + 1][LOG]);
}

/**long long build(int idx, int l, int r) {
    if (l == r) return segment[idx] = a[l];
    int m = (l + r) / 2;

    return segment[idx] = __gcd(build(2 * idx, l, m), build(2 * idx + 1, m + 1, r));
}

long long gcd(int idx, int l, int r, int ql, int qr) {
    if (l > r || ql > qr) return 0;
    if (qr < l || r < ql) return 0;
    if (ql <= l && r <= qr) return segment[idx];

    int m = (l + r) / 2;
    return __gcd(gcd(2 * idx, l, m, ql, qr), gcd(2 * idx + 1, m + 1, r, ql, qr));
}*/

long long get_power_2(int n) {
    int br = 0;

    while (n != 1) {
        br++;
        n /= 2;
    }

    return br;
}

long long get_2() {
    for (int i = 1; i <= n; i++) a[i] = get_power_2(a[i]);
    long long mx = 0;

    for (int lgmax = 30; lgmax >= 0; lgmax--) {
        int br = 0;

        for (int i = 1; i <= n; i++) {
            if (a[i] >= lgmax) br++;
            if (i == n || a[i + 1] < lgmax) {
                mx = max(mx, br * (long long) (1 << lgmax));
                br = 0;
            }
        }
    }

    return mx;
}

long long max_segment(vector <int> v) {
    n = v.size();
    bool f = true;


    for (int i = 0; i < n; i++) {
        a[i + 1] = v[i];
        if (__builtin_popcount(v[i]) != 1) f = false;
    }

    build(n);
    if (f) return get_2();

    long long mx = a[1];

    vector <int> l_values{1};

    for (int r = 2; r <= n; r++) { /// nlog
        if (gcd(r, r) != gcd(r - 1, r)) l_values.push_back(r); /// 1

        vector <int> next_l_values;

        for (int i = 0; i < l_values.size(); i++) { /// log
            if (i == 0 || gcd(l_values[i], r) != gcd(l_values[i - 1], r)) next_l_values.push_back(l_values[i]);
        }

        l_values = next_l_values; /// log

        for (int l : l_values) { /// log
            mx = max(mx, (r - l + 1) * gcd(l, r));
        }
    }

    return mx;
}
