#include <iostream>
using namespace std;
#define ll long long
#define D(x) cout << #x << ' ' << x << '\n'

ll ans[51][51][2];
ll bitmask[51];
int n, K;

inline bool isBlocked(int i, int j) {
	return (bitmask[i] & (1ULL << (n - j - 1))) != 0;
}

void clearTable(bool scnd) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			ans[i][j][scnd] = 0;
		}
	}
}

void populateTable(bool scnd) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (isBlocked(i, j)) {
				continue;
			}
			if (i != 0) {
				ans[i][j][scnd] += ans[i - 1][j][!scnd];
			}
			if (i != n - 1) {
				ans[i][j][scnd] += ans[i + 1][j][!scnd];
			}
			if (j != 0) {
				ans[i][j][scnd] += ans[i][j - 1][!scnd];
			}
			if (j != n - 1) {
				ans[i][j][scnd] += ans[i][j + 1][!scnd];
			}
		}
	}
}

char* in;

int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	in = nullptr;
	cin >> n >> K;
	for (int i = 0; i < n; i++) {
		in = new char[n]();
		cin >> in;
		for (int j = 0; j < n; j++) {
			bitmask[i] <<= 1;
			bitmask[i] |= (in[j] - '0');
		}
		delete[] in;
	}
	ans[0][0][1] = 1;
	for (int k = 0; k < K; k++) {
		clearTable(k & 1);
		populateTable(k & 1);
//		for (int i = 0; i < n; i++) {
//			for (int j = 0; j < n; j++) {
//				cout << ans[i][j][k & 1] << ' ';
//			}
//			cout << '\n';
//		}
//		cout << "\n\n";
	}
	cout << ans[n - 1][n - 1][(K + 1) & 1];
}
