#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int MAXCELLS = 1e6 + 1;
int N, M, K;
int Table[MAXCELLS];
bool Special[MAXCELLS];
bool Visited[MAXCELLS];
vector<int> Graph[MAXCELLS];
vector<int> Component;
int Component_Speacial;
llong Answer;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 1; i <= N; i++)
    {
        for(int j = 1; j <= M; j++)
        {
            int Value; cin >> Value;
            Table[(i - 1) * M + j] = Value;
        }
    }

    cin >> K;

    for(int i = 1; i <= K; i++)
    {
        int X, Y; cin >> X >> Y;
        X++;
        Y++;
        Special[(X - 1) * M + Y] = true;
        Answer += Table[(X - 1) * M + Y];

        if(X > 1)
        {
            Graph[(X - 1) * M + Y].push_back((X - 2) * M + Y);
            Graph[(X - 2) * M + Y].push_back((X - 1) * M + Y);
        }

        if(X < N)
        {
            Graph[(X - 1) * M + Y].push_back(X * M + Y);
            Graph[X * M + Y].push_back((X - 1) * M + Y);
        }

        if(Y > 1)
        {
            Graph[(X - 1) * M + Y].push_back((X - 1) * M + Y - 1);
            Graph[(X - 1) * M + Y - 1].push_back((X - 1) * M + Y);
        }

        if(Y < M)
        {
            Graph[(X - 1) * M + Y].push_back((X - 1) * M + Y + 1);
            Graph[(X - 1) * M + Y + 1].push_back((X - 1) * M + Y);
        }
    }
}

void Dfs(int U)
{
    if(Visited[U])
    {
        return;
    }

    Visited[U] = true;

    if(Special[U])
    {
        Component_Speacial++;
    }
    else
    {
        Component.push_back(Table[U]);
    }

    for(auto& V : Graph[U])
    {
        Dfs(V);
    }
}

void Solve()
{
    for(int i = 1; i <= N * M; i++)
    {
        if(Visited[i])
        {
            continue;
        }

        Component.clear();
        Component_Speacial = 0;
        Dfs(i);

        if(Component_Speacial * 3 > (int)Component.size())
        {
            cout << "No";
            return;
        }

        sort(Component.begin(), Component.end());
        reverse(Component.begin(), Component.end());

        for(int i = 0; i < Component_Speacial * 3; i++)
        {
            Answer += Component[i];
        }
    }

    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

