#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int MAXN = 51;
const int MAXK = 101;
int N, K;
char Table[MAXN][MAXN];
llong dp[MAXN][MAXN];
llong Previous[MAXN][MAXN];
int DirsX[5] = {0, 0, -1, 1};
int DirsY[5] = {-1, 1, 0, 0};

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K;

    for(int i = 0; i < N; i++)
    {
        cin >> Table[i];
    }
}

void Calculate(int X, int Y)
{
    for(int Rotate = 0; Rotate < 4; Rotate++)
    {
        int Nx = X + DirsX[Rotate];
        int Ny = Y + DirsY[Rotate];

        if(Nx < 1 || Nx > N || Ny < 1 || Ny > N)
        {
            continue;
        }

        if(Table[Nx - 1][Ny - 1] == '1')
        {
            continue;
        }

        dp[X][Y] += Previous[Nx][Ny];
    }
}

void Solve()
{
   Previous[1][1] = 1;

   for(int i = 1; i <= K; i++)
   {
       for(int X = 1; X <= N; X++)
       {
           for(int Y = 1; Y <= N; Y++)
           {
               dp[X][Y] = 0;
               Calculate(X, Y);
           }
       }

       for(int X = 1; X <= N; X++)
       {
           for(int Y = 1; Y <= N; Y++)
           {
               Previous[X][Y] = dp[X][Y];
           }
       }
   }

   cout << dp[N][N];
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
