#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int MAXN = 101;
int N, K;
llong Trees[MAXN];
pair<int, llong> Child[MAXN];
bool Station[MAXN];
int NewStation;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K;

    for(int i = 1; i <= N; i++)
    {
        llong T, V, W; cin >> Trees[i] >> V >> W;
        Child[i] = {V, W};
    }

    Station[0] = true;
}

llong Dfs(int U, int Root, int W)
{
    if(Station[U] || U == NewStation)
    {
        return W;
    }

    Dfs(Child[U].first, Root, W + Child[U].second * Trees[Root]);
}

void Solve()
{
    llong Answer = 0;

    for(int i = 1; i <= K; i++)
    {
        llong Min = 1e18, U;

        for(int i = 1; i <= N; i++)
        {
            if(Station[i])
            {
                continue;
            }

            NewStation = i;
            llong W = 0;

            for(int j = 1; j <= N; j++)
            {
                W += Dfs(j, j, 0);
            }

            if(W < Min)
            {
                Min = W;
                U = i;
            }
        }

        if(i == K)
        {
            Answer = Min;
        }
        else
        {
            Station[U] = true;
        }
    }

    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

