#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 64;
const int MAXK = 1e2 + 10;

int n, k;
char a[MAXN][MAXN];
ll dp[MAXN][MAXN][2];

pair < int, int > dir[4] = {
{1, 0},
{0, 1},
{-1, 0},
{0, -1}
};

void read()
{
    cin >> n >> k;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            cin >> a[i][j];
            a[i][j] -= '0';
        }
    }
}

void solve()
{
    if(a[1][1] == 1)
    {
        cout << 0 << endl;
        return;
    }

    dp[1][1][0] = 1;

    for(int cnt = 1; cnt <= k; cnt++)
    {
        for(int i = 1; i <= n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                dp[i][j][cnt % 2] = 0;

                if(a[i][j] == 1)
                    continue;

                for(int l = 0; l < 4; l++)
                {
                    pair < int, int > nb = {i + dir[l].first, j + dir[l].second};

                    if(a[nb.first][nb.second] == 1)
                        continue;

                    dp[i][j][cnt % 2] += dp[nb.first][nb.second][(cnt - 1) % 2];
                }
            }
        }
    }

    cout << dp[n][n][k % 2] << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}