#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 25;
const ll INF = 1e18 + 10;

int n;
int k;
int p[MAXN];
bool used[MAXN];
bool visited[MAXN];
int cnt[MAXN];
int d[MAXN];
ll ans = INF;
ll cur;

void read()
{
    cin >> n >> k;

    for(int i = 2; i <= n + 1; i++)
    {
        cin >> cnt[i] >> p[i] >> d[i];
        p[i]++;
    }
}

void push(int node, int c, int dist)
{
    ///cout << "Current node : " << node << endl;
    ///cout << "Current carry : " << c << endl;
    cur = cur + c * dist;

    if(used[node] || node == 1)
        return;

    push(p[node], c + cnt[node], d[node]);
}

void check(int mask)
{
    ///cout << "Current mask : " << mask << endl;

    used[1] = true;

    ///cout << endl;
   /// cout << "Marked cities : " << endl;

    for(int i = 2; i <= n + 1; i++)
    {
        used[i] = false;
        if(mask & (1 << (i - 1)))
        {
            ///cout << i << " ";
            used[i] = true;
        }
    }
   /// cout << endl << endl;

    cur = 0;

    for(int i = 2; i <= n + 1; i++)
    {
        ///cout << "Pushing for node : " << i << endl;
        ///cout << endl;
        push(i, 0, 0);
        ///cout << endl;
        /// cout << "Ending pushing for node : " << i << endl;
        ///cout << "Cost after node : " << i << " -> " << cur << endl;
    }

   /// cout << endl << endl;

    ///cout << "Cost for this mask : " << cur << endl;

    ans = min(ans, cur);

    ///cout << endl << endl;
}

void solve()
{
    for(int mask = 0; mask < (1 << (n + 1)); mask++)
    {
        if(mask & 1)
            continue;

        int cnt = __builtin_popcount(mask);

        if(cnt != k)
            continue;

        // for(int i = 1; i <= n + 1; i++)
        // {
        //     cout << (bool)(mask & (1 << (i - 1))) << " ";
        // }
        // cout << endl;

        check(mask);
    }

    cout << ans << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ///cout << "qzh mi chepa" << endl;
    read();

   /// cout << "mina cheteneto" << endl;
    solve();

    ///cout << "daima" << endl;

    return 0;
}