#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 3e6 + 10;
const int MAXLOG = 24;

ll st[MAXN][MAXLOG];
ll a[MAXN];
ll lg[MAXN];
ll n;

void fill_st()
{
    for(int i = 1; i <= n; i++)
    {
        st[i][0] = a[i];
    }

    for(int j = 1; j < MAXLOG; j++)
    {
        for(int i = 1; i + (1 << j) - 1<= n; i++)
        {
            st[i][j] = __gcd(st[i][j - 1], st[i + (1 << (j - 1))][j - 1]);
        }
    }

    for(int i = 2; i <= n; i++)
    {
        lg[i] = lg[i / 2] + 1;
    }
}

ll query(int left, int right)
{
    int len = right - left + 1;
    int k = lg[len];

    return __gcd(st[left][k], st[right - (1 << k) + 1][k]);
}

ll solve()
{
    ll ans = 0;
    pair < int, int > p;
    for(int left = 1; left <= n; left++)
    {
        for(int right = left; right <= n; right++)
        {
            int len = right - left + 1;
            ll cost = len * query(left, right);
            if(ans < cost)
            {
                ans = cost;
                p = {left, right};
            }
        }
    }

    return ans;
}

ll max_segment(vector<int> A)
{
    n = A.size();
    for(int i = 0; i < n; i++)
    {
        a[i + 1] = A[i];
    }
    fill_st();
    return solve();
}